// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/api"
	model "LAPP_LF_MOM_BACKEND/models/api"
	omModel "LAPP_LF_MOM_BACKEND/models/om"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : VwPlanInfoDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : VwPlanInfo的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-18 10:52:46
 *
 ******************************************************************************/
type VwPlanInfoDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewVwPlanInfoDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个VwPlanInfoDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *

 * @Return Value             : VwPlanInfoDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-18 10:52:46
 *
 ******************************************************************************/
func NewVwPlanInfoDAOImplement(session *xorm.Session, userid string) *VwPlanInfoDAOImplement {
	return &VwPlanInfoDAOImplement{session, &meta.VwPlanInfo, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.InsertOne
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) InsertOne(entity *model.VwPlanInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) DeleteOne(barcode string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{barcode}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.SelectOne
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) SelectOne(barcode string) (*model.VwPlanInfo, error) {
	var data model.VwPlanInfo
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{barcode}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) UpdateOne(entity *model.VwPlanInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.Insert
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) Insert(entities *[]model.VwPlanInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.Delete
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) Delete(entities *[]model.VwPlanInfo) error {
	for _, entity := range *entities {

		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.Select
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.VwPlanInfo, error) {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.VwPlanInfo, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by "
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.VwPlanInfo, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.Update
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) Update(entities *[]model.VwPlanInfo) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]

		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.VwPlanInfo, columns ...string) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/VwPlanInfoDAO.SelectNeedParseData
 *
 ******************************************************************************/
func (impl *VwPlanInfoDAOImplement) SelectNeedParseData(date string, taskType string) ([]model.VwPlanInfo, error) {
	data := make([]model.VwPlanInfo, 0)
	session := impl.session.Table(impl.meta.TableName)
	var where string
	if taskType == omModel.ParseTaskTypeByDay {
		where = fmt.Sprintf("%s >= ?", meta.VwPlanInfo_PlanDttm.ColumnName)
		datetime := date + " 00:00:00"
		err := session.Where(where, datetime).OrderBy(meta.VwPlanInfo_AutoId.ColumnName).Find(&data)
		return data, err
	} else {
		where = fmt.Sprintf("%s >= ? and %s <= ?", meta.VwPlanInfo_PlanDttm.ColumnName, meta.VwPlanInfo_PlanDttm.ColumnName)
		begin := date + " 00:00:00"
		end := date + " 23:59:59"
		err := session.Where(where, begin, end).OrderBy(meta.VwPlanInfo_AutoId.ColumnName).Find(&data)
		return data, err
	}
}
